
jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]

SetScene{
	glowpasses = ifhifi(0,0),
	glowspread = ifhifi(0,0),
	radialblur_strength = 4,
	watertype = 0,
	water = jumping,
	watertint = {r=0,g=0,b=0,a=0},
	towropes = jumping,
	airdebris_count = ifhifi(20000,2000),
	airdebris_density = ifhifi(20,2),
	airdebris_particlesize = fif(jumping, 0.2, 0.2),
	airdebris_fieldsize = 300,
	airdebris_layer = 13,
	hide_default_background_verticals = true,
	usedefaultrails=false,
	useblackgrid=false,
	twistmode= {curvescaler=6.0,steepscaler=1.7}
}
SetBlockFlashes{
	sizescaler=0,
	sizescaler_missed = 0
}
if not jumping then
	SetBlocks{
		colorblocks={
			mesh = "DoubleLozenge.obj",
			shader = "RimLight",
			texture = "DoubleLozenge.png",
		    height = 0,
		    float_on_water = false,
		    scale = {1,1,1}
		},
		greyblocks={
			mesh = "Rock3.obj",
			shader = "RimLight",
			texture = "rock1.png"
		}
	}
	
		SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,2,-0.8},
			rot={20,0,0}},
		camthird={
			pos={0,5,-4},
			rot={28,0,0},
			strafefactor = 0.75,
			pos2={0,5,-4},
			rot2={28,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
			
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=0},
			mesh="ninjamono.obj",
			shader="VertexColorUnlitTinted",
			shadersettings={_GlowScaler=9, _Brightness=.66},
			layer = 15,
			renderqueue = 2000,
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture="ninjamono.png",
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
						perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
						--shader="VertexColorUnlitTinted",
						shader="VertexColorUnlitTintedAddSmooth",
						layer = 14,
						renderqueue = 2999,
						colorscaler = 2,
						extrusions=22,
						stretch=-0.1191,
						updateseconds = 0.025,
						instances={
							{pos={0,.46,-1.28},rot={0,0,0},scale={.7,.7,.7}},
							{pos={.175,0.21,-1.297},rot={0,0,58.713},scale={.7,.7,.7}},
							{pos={-.175,0.21,-1.297},rot={0,0,313.7366},scale={.7,.7,.7}}
						}}
		}
	}
end

SetSkybox{
	skysphere = "jee.jpg",
}

SetTrackColors{
    {r=214, g=0, b=254},
    {r=0, g=176, b=255},
    {r=0, g=184, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0}
}

SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}

SetRings{
	texture="portal_onblack.png",
	shader="VertexColorUnlitTintedAddSmooth",
	layer = 13,
	size=0,
	percentringed=.2,
	airtexture="portal_onblack.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=0
}

wakeHeight = 2
if jumping then wakeHeight=2 else wakeHeight = 0 end
SetWake{
	height = wakeHeight,
	fallrate = 0.95,
	shader = "VertexColorUnlitTinted",
	layer = 13,
	bottomcolor = {r=0,g=0,b=100},
	topcolor = "highway"
}

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	gameobject={
		pos={x=0,y=0,z=0},
		--mesh="skyscraper42.obj",
		mesh="rock2.obj",
		--shader="VertexColorUnlitTintedAlpha",
		shader="Diffuse",
		diffuseinair = true,
		shadercolors={
			_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="rock2.png",
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}

track = GetTrack()
if buildingNodes == nil then
	buildingNodes = {}
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}
	for i=1,#track do
		if i%80==0 then
		for jjj=1,5 do
			buildingNodes[#buildingNodes+1] = i
			local xOffset = jjj * 14 + 5*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			local yOffset = jjj * 14 + 5*math.random()
			if math.random() > 0.5 then yOffset = yOffset * -1 end
			offsets[#offsets+1] = {xOffset,yOffset,(2 - jjj) * (4 + 3 * jjj)}
			end
		end
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe",
							locations=buildingNodes,
                    		rotateWithTrack=false,
                    		maxShown=150,
                    		maxDistanceShown=2000,
							offsets=offsets,
							collisionLayer = 1,
							testAndHideIfCollideWithTrack=false
						}


end
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="zzzap",
	visible=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="clock.obj",
		--shadowcaster=true,
		--layer = iflofi(13,18),
		shader="VertexColorUnlitTintedAddSmooth",
		shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
		texture="portal_onblack.png",
		scale = {x=.45,y=.45,z=1}
	}
}
Nodes_Zone2 = {}
--RotationSpeeds_Zone = {}
RotationSpeeds_Zone6 = {}
for i=1,#track do
			if track[i].intensity > 0.85 then
			Nodes_Zone2[#Nodes_Zone2+1] = i 
			--RotationSpeeds_Zone[#RotationSpeeds_Zone+1] = {0,0,-5000}
				RotationSpeeds_Zone6[#RotationSpeeds_Zone6+1] = {0,0,50}
				end
			end
BatchRenderEveryFrame{
	prefabName="zzzap", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = Scales,
	rotationspeeds = RotationSpeeds_Zone6,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 3,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}