---Doctor Who by Dj Pavlusha---


jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]

SetScene{
	glowpasses = ifhifi(0,0),
	glowspread = ifhifi(0,0),
	radialblur_strength = 1,
	watertype = 0,
	water = false,
	watertint = {r=250,g=250,b=250,a=30},
	watertexture = "White.png",
	towropes = false,
	airdebris_count 	= 35000,
	airdebris_density 	= ifhifi(120,2),
	airdebris_particlesize = particleBaseSize, -- fif(jumping, 0.12, 0.09),
	airdebris_fieldsize = 270,
	airdebris_layer 	= 13,
	airdebris_flashsizescaler = .1,
	airdebris_texture 	= "star.png",	
	usedefaultrails=false,
	useblackgrid=true,
	fullfuture = true,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep,1,.65)}
}
AddPostEffect{
		depth= "foreground",
		builtin={
			name="AmplifyColor",
			--lut = "LUT'S/HDR.png"
			lut = "robot action.png"
			--BlendAmount = 1,
			--LutBlendTexture = "LUT'S/vibrance 2.png",
			--Masktexture = "LUT'S/Mask.png"

		}
	}
	SetBlocks{
		
		greyblocks={
			mesh = "3.obj",
			shader = "RimLight",
			texture = "black.png"},
		powerups={
			ghost={mesh = "5.obj",
			shader = "RimLight",
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture = "White.png"},

			powerpellet={mesh = "6.obj",
			shader = "RimLight",
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture = "White.png"}
		}
	}
	
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,2.5,-1},
			rot={20,0,0}},
		camthird={
			pos={0,2,-2},
			rot={20,0,0},
			strafefactor = 0.75,
			pos2={0,5,-4},
			rot2={28,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
			
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=0},
			mesh="tardis.obj",
			shader = "VertexColorUnlitTinted",
			layer = 14,
			renderqueue = 2000,
			shadercolors={
			_Color={255,255,255}},
			texture="tardis.jpg",
			scale = {x=1,y=1,z=1},
		}
	}



randomspace = math.random(1,7)
SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
	color = {r=255,g=255,b=255,a=0},
	custom={
		_FrontTex = "s" .. randomspace .. "1.png",
		_BackTex = "s" .. randomspace .. "2.png",
		_RightTex = "s" .. randomspace .. "3.png",
		_LeftTex = "s" .. randomspace .. "4.png",
		_UpTex = "s" .. randomspace .. "5.png",
		_DownTex = "s" .. randomspace .. "6.png"
	}
}


SetBlockFlashes{
	texture="Black.png"
}

SetTrackColors{
    {r=89, g=105, b=140},
	{r=69, g=85, b=140},
	{r=89, g=105, b=140},
    {r=123, g=97, b=153},
	{r=193, g=90, b=47},
	{r=193, g=90, b=47},
	{r=123, g=97, b=153},
	{r=89, g=105, b=140},
	{r=69, g=85, b=140},
	{r=89, g=105, b=140},
	{r=123, g=97, b=153},
	{r=193, g=90, b=47},
    {r=193, g=90, b=47}
}

SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}

randomvortex = math.random(1,2)
SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	
	texture = "r" .. randomvortex .. ".png",
		shader="VertexColorUnlitTintedAddSmooth",
        size=30,
	percentringed=.6,
		airtexture="r" .. randomvortex .. ".png",
		airshader="VertexColorUnlitTintedAddSmooth",
		airsize=16
}
CreateObject{
	name="Earth",
	tracknode="end",
	gameobject={
		scale = {x=7,y=7,z=7},
		mesh="earth.obj",
		shader="VertexColorUnlitTinted",
		shadercolors={
			_Color={255,255,255}
		},
		texture="earth.jpg"
	}
}

SetWake{
	height = 0,
	fallrate = 0.95,
	shader = "VertexColorUnlitTinted",
	layer = 13,
	bottomcolor = {r=175,g=175,b=175},
	topcolor = "highway"
}