--[[Most of this code was not done by me. The base code was used from Rainbowish by Kiisseli with some colour pallet edits as well as changes to wakes done solely by me. Parts that were not in either of those were based off of code from other skins and/or were edited by me or Kiisseli. The only credit I should get is the idea of making this and bringing it all together.]]
--[[
   ________             ______           __  _     
  / ____/ /___ _      _/_  __/___ ______/ /_(_)____
 / / __/ / __ \ | /| / // / / __ `/ ___/ __/ / ___/
/ /_/ / / /_/ / |/ |/ // / / /_/ (__  ) /_/ / /__  
\____/_/\____/|__/|__//_/  \__,_/____/\__/_/\___/  
Edit by Classified ]]

jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

lofi = GetQualityLevel() > 1 -- GetQualityLevel returns 1,2,or 3
function iflofi(if_true, if_false)
  if lofi then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

quality = GetQualityLevel4()
function ByQuality4(low,med,high,ultra)
	if quality < 2 then return low
	elseif quality <3 then return med
	elseif quality <4 then return high
	else return ultra end
end

white = {1, 1, 1}
function greyscale(amount, alpha) return {amount,amount,amount,alpha} end -- can omit alpha
intensityaurora = true
skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
--trackWidth = 11.5 -- uses a wide water track even for vehicles
fullsteep = jumping or skinvars.prefersteep

do
        local entropy = math.random(9000000) -- keep the song-based entropy AS2 is giving us
       
        local function addEntropy(seed)
                if seed == nil then
                        seed = math.random(9000000)
                elseif type(seed) ~= "number" then
                        if type(seed) ~= "string" then seed = tostring(seed) end -- for functions and tables this will use their raw memory address for entropy
                        if seed == "" then seed = "12" end
                        local numbers = {string.byte(seed, 1, #seed)}
                        seed = 0
                        for i=1,#numbers do seed = seed + numbers[i] end
                end
                entropy = entropy + seed
        end
       
        -- if only it were that easy!
        if type(os) == "table" and type(os.time) == "function" then
                addEntropy(os.time())
        end
       
        -- this is fun, finding things to throw into the shredder
        addEntropy(collectgarbage("count") * 1024)
        addEntropy({})
        addEntropy(addEntropy)
        addEntropy(BatchRenderEveryFrame)
        local skinvars = GetSkinProperties()
        addEntropy(skinvars)
        for k, v in pairs(skinvars) do
                addEntropy(k)
                addEntropy(v)
                if type(v) == "table" then
                        local success, result = pcall(table.concat, v)
                        addEntropy(result)
                end
        end
       
        -- "math.randomseed will call the underlying C function srand which takes an unsigned integer value"
        local UINT_MAX = 4294967295
        while entropy > UINT_MAX do entropy = entropy - UINT_MAX end
        while entropy < 0 do entropy = entropy + UINT_MAX end
       
        print("rng seed: " .. entropy)
        math.randomseed(entropy)
end

SetScene{
	ambientlight = "highway",	 
	glowpasses = ifhifi(4,4),
	glowspread = ifhifi(4,4),
	radialblur_strength = ifhifi(0.5,0),
	hide_default_background_verticals = true,
	watertype = 1,
	water = jumping, --only use the water cubes in wakeboard mode
	towropes = jumping,--use the tow ropes if jumping
	airdebris_count = ifhifi(2000,500),
	airdebris_density = ifhifi(1,1),
	airdebris_texture = "firework64.png",
	airdebris_flashsizescaler = .2,

	crease_strength=ifhifi(-47,0),
	closecam_near=.05,
	closecam_far=22 --bringing this in closer than the default (50) improves the ship's shadow quality
	--twistmode={curvescaler=1, steepscaler=.1} -- note: "cork" is the same as {curvescaler=1, steepscaler=1} and "cork_flatish" is the same as {curvescaler=1, steepscaler=.4}
}
SetBlockFlashes{
	texture="black.png"
}
--[[]]
if hifi then
	radialBlurEffect = BuildMaterial{ -- background radial blur (seen mostly on star air debris trails)
		shader="PostRadialBlur",
		shadersettings={_Amount=.035, _Center={.5,.5,0}}
	}
--
	AddPostEffect{
		depth="background",
		material = radialBlurEffect
	}

end


	local white = 50,50,50
		local shipMesh = BuildMesh{
			mesh="junship90.obj",
			--mesh="ninjamono.obj",
			barycentricTangents = true, --for use with wireframe shaders
			--calculateTangents = true,
			calculateNormals = true,
			submeshesWhenCombining = false
		}

		shipMaterial = BuildMaterial{
			renderqueue = 2000,
			--shader="UnlitTintedTexGlowWire",
			--shader="VertexColorUnlitTintedAddSmooth",
			shader="SelfGlowBumpSpec2_compiled.shader",
			shadersettings={_Shininess=3, _GlowScaler=9},
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=0, maxscaler=2.5},
				_SpecColor = {colorsource="highway", scaletype="intensity", minscaler=0, maxscaler=2.5},
				_GlowColor = {colorsource="highway", scaletype="intensity", minscaler=0, maxscaler=2.5}
				},
			textures={_MainTex="maintex_darkerNeg170_highlights.png", _BumpMap="normal.png", _Glow="glowBW.png"},
		}

		vehicleTable={
			min_hover_height= 0.11,
			max_hover_height = 1.4,
			use_water_rooster = false,
            smooth_tilting = false,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=0},

			mesh = shipMesh,--built with BuildMesh above
			--materials = {shipMaterial}, --assign the pre-created material
			material = shipMaterial,
			layer = 15,
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
						perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
						shader="TransparentShadowCaster",
						layer = 14,
						renderqueue = 3000,
						colorscaler = {close=2.5, far=0},
						sizefalloff = 1,
						minrenderedsize = 0.05,
						extrusions=25,
						stretch=-0.1191,
						updateseconds = 0.025,
						instances={
							{pos={0,0.40,-1.62},rot={0,0,0},scale={0.6,0.6,0.6}},
							{pos={0,0.40,-1.62},rot={0,0,0},scale={0.45,0.45,0.8}},
							{pos={0,0.40,-1.62},rot={0,0,0},scale={0.3,0.3,0.8}},
							{pos={0,0.40,-1.62},rot={0,0,0},scale={0.1,0.1,0.8}},

							{pos={0.21,0.52,-1.60},rot={0,0,0},scale={0.3,0.3,0.66}},
							{pos={0.21,0.52,-1.60},rot={0,0,0},scale={0.1,0.1,0.66}},

							{pos={-0.21,0.52,-1.60},rot={0,0,0},scale={0.3,0.3,0.66}},
							{pos={-0.21,0.52,-1.60},rot={0,0,0},scale={0.1,0.1,0.66}}
						}}
		}

	SetPlayer{
		--showsurfer = false,
		--showboard = false,
		cameramode = "third",
	--	cameramode_air = "first",--"first_jumptrickthird", --start in first, go to third for jumps and tricks

		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0}},
		camthird={
			pos={0,4,-1.5},
			rot={30,0,0},
			strafefactor = 0.75,					--[.75]
			pos2={0,5,-4},								--[0 5 -4] 
			rot2={30,0,0},								--[30 0 0]
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.65,
			puzzleoffset2=-1.5},
		vehicle=vehicleTable
	}

SetSkybox{
skyscreen = "Skyscreen/TheGridAdditive"
	}
if hifi then
	CreateLight{
		railoffset = -3,
		range = 10,
		intensity = 2,
		transform = {
			position={0,.5,0}
		},
		color="highway"
	}
	CreateLight{
		railoffset = -7.5,
		range = 10,
		intensity = 2,
		transform = {
			position={0,.5,0}
		},
		color="highway"
	}
		CreateLight{
		railoffset = 7.5,
		range = 10,
		intensity = 2,
		transform = {
			position={0,.5,0}
		},
		color="highway"
	}
end
track_colors_choices = {
{										--Waltz
{0,0,0},
    {200,10,40}, --hot magenta
    {200,18,100},--magenta
	{0,0,0},
    {200,30,100},--purple
	--{250,43,239},--Rose Fuchsia
	{31,94,86}, --ocean green
    {200,20,190},--purple
    {25,25,112},--blue
    {100,15,200},--dark purple
    {39,45,200},--another blue
    {0,183,104},--seafoam green
    {12,20,122},--dark blue
},
{										--Burning Skies
{0,0,0},
    {200,30,15}, --red orange
    {246,159,15},--orange
    {200,10,40}, --hot magenta
{0,0,0},
    {200,30,100},--purple
    {25,25,112},--blue
	{9,112,66},--dark green
    {100,15,200},--dark purple
    {39,45,200},--another blue
    {33,210,130},--seafoam green
    {200,30,15},--cool red
{0,0,0},
},

{										--Nova
{0,0,0},
	{69,13,96},--black magenta
    {3,37,77},--deep blue
	{0,30,100},--less deep blue
    {0,60,174},--blue
    {0,60,130},--deep blue
    {150,0,0},--dark red
    {0,60,120},--dark blue
{0,0,0},
    {140,20,20}, --crimson
    --{100,60,130},--deep blue
    --{50,50,130},--very dark blue
	{0,20,180},
    {104,0,148},--dark magenta
	{0,25,150},
	--{25,40,180},
	{25,50,112}, --dark violet
    {0,60,255},--bright blue
	{75,0,130},
},
{										--Inferno
{0,0,0},
	{50,50,50}, --dark grey
	{90,90,90}, --grey
	{58,16,61}, --dark violet
    {50,0,0}, --black red
    {100,0,10},--dark red
{0,0,0},
	{50,50,50}, --dark grey
	{90,90,90}, --grey
	{37,13,126}, --dark purple
	{105,0,22}, --dark maroon
	{163,16,44}, --maroon
	{223,17,7}, --red
	{58,16,61}, --dark violet
{0,0,0},
	{100,0,10}, --deep red
	{245,77,22}, --orange
},
{										--Galaxy
{0,0,0},
	{220,20,40}, --red
	{248,70,49}, --orange red
    {219,46,104}, --magenta
    --{248,70,49}, --orange red
    {94,6,64}, --midnight satin
	{216,67,21}, --pure light
    {28,26,84}, --deep blue
    {10,10,10}, --deep black
},
{										--Magic
{0,0,0},
{0,0,0},
	{0,184,0},--green
    {75,0,130},--purple
    {25,25,112}, --dark violet
    --{182,134,24},--yelloworange
	{220,20,20}, --crimson
{0,0,0},
	{128,0,0}, --maroon
    {255,69,0},--orange
    {0,8,79},--blue
	{12,149,203},--light blue
},
{										--Adrenalin
{0,0,0},
	{12,10,87}, --very dark blue
	{0,87,37}, --dark green
	{124,164,8}, --yellow
	{153,21,21}, --dark red
	{207,138,10}, --orange
	{160,5,5}, --crimson
	{247,57,57}, --bright red
	{12,10,87}, --very dark blue
	--{194,194,8}, --yellow
	{153,21,21}, --dark red
	{207,138,10}, --orange
	{160,5,5}, --crimson
	{247,57,57}, --bright red
},
}

SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}

track_colors_index = math.random(#track_colors_choices)
track_colors = track_colors_choices[track_colors_index]
SetTrackColors(track_colors)
palette_names = {"Waltz", "Burning Skies", "Nova", "Inferno", "Galaxy", "Magic", "Adrenalin"}
palette_index = palette_names[track_colors_index]
-- [track_colors_index] can be replaced with [#] to force a color palette
print("                                        " .. palette_index)
print("Random Track Color Palette: #" .. track_colors_index)


	SetBlocks{
		maxvisiblecount = 200, -- fif(skinvars.minvisibleblocks, math.max(200, skinvars.minvisibleblocks), 200),
		colorblocks={
			mesh = "block.obj", --  ballMesh, --"DoubleLozenge.obj",
			shader = fif(ispuzzle, "Diffuse", "Rim Light"),
			shadersettings={_Brightness=0.42},
			texture = "white.png",
		    height = 0,
		    float_on_water = false,
		    scale = {0.9,0.9,0.9},
		},
			greyblocks={
			mesh = "singlespike.obj",
			shader = "VertexColorUnlitTinted",
			texture = "doublespike.png"
		},
}






SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture="white.png",
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAddSmooth",
	size=0,
	percentringed=.2,--ifhifi(2,.01),-- .2,
	airtexture="white.png",
	airshader="VertexColorUnlitTintedAddSmooth",
	airsize=16,
	colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=2
}

--if jumping then wakeHeight=(ifhifi(4,2)) else wakeHeight = 0 end
wakeHeight=0--(ifhifi(4,2))
--wakeStrafe = 14.7
--if not jumping then wakeHeight = 1.75 end
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = 1.0,
	shader = "VertexColorUnlitTinted",
	layer = 12, -- looks better not rendered in background when water surface is not type 2
	bottomcolor = {0,0,0},
	--topcolor = highway,
	topcolor = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=6, param="_Threshold", paramMin=2, paramMax=2},
	extraspray = true
}

function Update(dt, trackLocation, playerStrafe, playerJumpHeight, intensity)
	if shipMaterial then
		local enginePower = 3 + 20*intensity
		UpdateShaderSettings{material=shipMaterial, shadersettings={_GlowScaler=enginePower}}
	end
end

if intensityaurora then shaderset = {_Color = {colorsource="aurora", scaletype="intensity", minscaler=0.33, maxscaler=2.5}} end


	CreateRail{--road surface
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=-trackWidth,y=0},
			{x=trackWidth,y=0}},
		colorMode="aurora",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,
		renderqueue=3001,
		--texture="subroad.png",
		shader="VertexColorUnlitTintedAddSmooth",
		shadercolors=shaderset
		--shadercolors={_Color={r=30,g=30,b=30,a=155}}
	}

	auroraExtent = ifhifi(1,3)
	auroraHeight = 1.0 * (auroraExtent / .50)
	CreateRail{--left aurora
		positionOffset={
			x=-trackWidth,
			y=0},
		crossSectionShape={
			{x=-auroraExtent,y=auroraHeight},
			{x=0,y=.5},
			{x=0,y=-.5},
			{x=-auroraExtent,y=auroraHeight-1}},
		perShapeNodeColorScalers={
			0,
			1,
			1,
			0},
		colorMode="aurora",
		color = {r=255,g=255,b=255},
		flatten=false,
	    layer=13,
	    renderqueue=3000,
		texture="White.png",
		shader="VertexColorUnlitTintedAddDouble",
		shadercolors=shaderset
	}

	CreateRail{--right aurora
		positionOffset={
			x=trackWidth,
			y=0},
		crossSectionShape={
			{x=0,y=.5},
			{x=auroraExtent,y=auroraHeight},
			{x=auroraExtent,y=auroraHeight-1},
			{x=0,y=-.5}},
		perShapeNodeColorScalers={
			1,
			0,
			0,
			1},
		colorMode="aurora",
		color = {r=255,g=255,b=255},
		flatten=false,
	    layer=13,
		texture="White.png",
		renderqueue=3000,
		shader="VertexColorUnlitTintedAddDouble",
		shadercolors=shaderset
	}	


if jumping then
	CreateRail{--left rail
		positionOffset={
			x=-trackWidth,
			y=0},
		crossSectionShape={
			{x=-.95,y=1.4},
			{x=0,y=1},
			{x=0,y=-3},
			{x=-.95,y=-3}},
		perShapeNodeColorScalers={
			.5,
			1,
			0,
			0},
		colorMode="highway",
		color = {r=255,g=255,b=255},
		flatten=false,
		texture="cliffRails.png",
		shader="CliffRail"
	}

	CreateRail{--right rail
		positionOffset={
			x=trackWidth,
			y=0},
		crossSectionShape={
			{x=0,y=1},
			{x=.95,y=1.4},
			{x=.95,y=-3},
			{x=0,y=-3}},
		perShapeNodeColorScalers={
			1,
			.5,
			0,
			0},
		colorMode="highway",
		color = {r=255,g=255,b=255},
		flatten=false,
		texture="cliffRails.png",
		shader="CliffRail"
	}
end
auroraExtent = 77
CreateRail{--left aurora core
			positionOffset={
			x=-trackWidth - .2,
			y=0},
		crossSectionShape={
				{x=-.99,y=.5},
				{x=0.5,y=.5},
				{x=0.5,y=.2},
				{x=-0.99,y=.2}},
			perShapeNodeColorScalers={
				1,
				1,
				1,
				1},
			colorMode="aurora",
			renderqueue=3000,
			color = {r=127,g=127,b=127},
			flatten=false,
			texture="White.png",
			shader="VertexColorUnlitTintedAddSmooth"
		}

		CreateRail{--right aurora core
			positionOffset={
			x=trackWidth + .2,
			y=0},
		crossSectionShape={
				{x=-.5,y=.5},
				{x=.50,y=.5},
				{x=.50,y=.2},
				{x=-.5,y=.2}},
			perShapeNodeColorScalers={
				1,
				1,
				1,
				1},
			colorMode="aurora",
			renderqueue=3000,
			color = {r=127,g=127,b=127},
			flatten=false,
			texture="White.png",
			shader="VertexColorUnlitTintedAddSmooth"
		}

CreateRail{--left aurora
	positionOffset={
		x=-trackWidth +11, 
		y=0},
	crossSectionShape={
		{x=-auroraExtent,y=.5},
		{x=-11,y=.5},
		{x=-11,y=-.5},
		{x=-auroraExtent,y=-.5}},
	perShapeNodeColorScalers={
		0,
		1,
		1,
		0},
	colorMode="aurora",
	color = {r=255,g=255,b=255},
	flatten=false,
	fullfuture = true,
    layer=11,
	texture="White.png",
	shader="VertexColorUnlitTintedAddSmooth",
	shadercolors=shaderset
}

CreateRail{--right aurora
	positionOffset={
		x=trackWidth -11, 
		y=0},
	crossSectionShape={
		{x=11,y=.5},
		{x=auroraExtent,y=.5},
		{x=auroraExtent,y=-.5},
		{x=11,y=-.5}},
	perShapeNodeColorScalers={
		1,
		0,
		0,
		1},
	colorMode="aurora",
	color = {r=255,g=255,b=255},
	flatten=false,
	fullfuture = true,
    layer=11,
	texture="White.png",
	shader="VertexColorUnlitTintedAddSmooth",
	shadercolors=shaderset
}

	CreateRail{ -- right lane borderthing
			positionOffset={
				x=trackWidth + 1,
				y=0.9},
			crossSectionShape={
				{x=-.04,y=-0.1},
				{x=.04,y=0.1}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="static",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = true,
			shader="VertexColorUnlitTintedQuadruple"
		}
		
		CreateRail{ -- left lane borderthing
			positionOffset={
				x=-trackWidth -1,
				y=0.9},
			crossSectionShape={
				{x=.04,y=-0.1},
				{x=-.04,y=0.1}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="static",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = true,
			shader="VertexColorUnlitTintedQuadruple"
		}
		
		CreateRail{ -- left lane line
			positionOffset={
				x=-trackWidth,
				y=.2},
			crossSectionShape={
				{x=.04,y=-0.1},
				{x=-.04,y=0.1}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="static",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = true,
			shader="VertexColorUnlitTintedQuadruple"
		}
		
			CreateRail{ -- right lane line
			positionOffset={
				x=trackWidth,
				y=.2},
			crossSectionShape={
				{x=-.04,y=-0.1},
				{x=.04,y=0.1}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="static",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = true,
			shader="VertexColorUnlitTintedQuadruple"
		}
