jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]

SetScene{
	glowpasses = ifhifi(0,0),
	glowspread = ifhifi(0,0),
	radialblur_strength = 1,
	watertype = 0,
	water = false,
	watertint = {r=250,g=250,b=250,a=30},
	watertexture = "transparent.png",
	towropes = false,
	airdebris_count = ifhifi(1,1),
	airdebris_density = ifhifi(1,1),
	usedefaultrails=false,
	useblackgrid=false,
	fullfuture = true,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep,1,.65)}
}

	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,2.5,-1},
			rot={20,0,0}},
		camthird={
			pos={0,2,-2},
			rot={20,0,0},
			strafefactor = 0.75,
			pos2={0,5,-4},
			rot2={28,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
			
		vehicle={
			min_hover_height= 1.5,
			max_hover_height = 1.5,
			use_water_rooster = false,
            smooth_tilting = false,
            rollscaler = -0.2,
			panscaler = .14,
			pos={x=0,y=0,z=0},
			scale={1,1,1},
			mesh="particle.obj",
			shader="MatCap/Vertex/PlainBrightGlow",
				shadersettings = fif(hifi, {_Brightness=4.0}, {_Brightness=5.5}, {_GlowColor=255,255,255}, {_GlowScaler=1.0}),
				textures = {_MainTex = "White.png", _MatCap = "matcapchrome.jpg", _Glow = "discharges.png"},
					shadercolors={
				_Color = {colorsource="highwayinverted", scaletype="intensity", minscaler=1, maxscaler=1}},
			layer = 14,
			renderqueue = 2000,
		}
	}
skyUpdateCounter = 0
mufframe=0
mufframe1=0
function Update(dt)
	skyUpdateCounter = skyUpdateCounter + dt
	if(skyUpdateCounter > .02) then--don't update sky colors every frame
mufframe=mufframe+1
mufframe1=mufframe1+1
	skyUpdateCounter = 0
	SetBlocks{
	greyblocks={
	    	mesh = "bh.obj",
		shader = "Unlit/Transparent",
		texture = "blackhole"..mufframe1..".png",
		scale = {1,1,1}
	},
		powerups={
		ghost={
			mesh = "bh.obj",
			shader = "Unlit/Transparent",
			texture = "higgs"..mufframe..".png",
			scale = {1,1,1}
		},
		powerpellet={
			mesh = "bh.obj",
			shader = "Unlit/Transparent",
			texture = "higgs"..mufframe..".png",
			scale = {1,1,1}
		}
	}
	}
if(mufframe == 4) then
		mufframe=0
		end
		if(mufframe1 == 122) then
		mufframe1=0
		end
	end
end
SetBlocks{
allow_mod_block_scaling = false,
	colorblocks={
		mesh="particle.obj",
		shader="MatCap/Vertex/PlainBrightGlow",
				shadersettings = fif(hifi, {_Brightness=4.0}, {_Brightness=5.5}, {_GlowColor=255,255,255}, {_GlowScaler=1.0}),
				textures = {_MainTex = "White.png", _MatCap = "matcapchrome.jpg", _Glow = fif(flag,"particlehit.jpg","discharges.png")},
					shadercolors={
				_Color = {colorsource="highwayinverted", scaletype="intensity", minscaler=1, maxscaler=1}},
				scale={1,1,1}
	},
	greyblocks={
	    	mesh = "bh.obj",
		shader = "Unlit/Transparent",
		texture = "blackhole1.png",
	},
	powerups={
		ghost={
			mesh = "bh.obj",
			shader = "Unlit/Transparent",
			texture = "higgs1.png",
		},
		whiteblock={
			mesh = "bh.obj",
			shader = "Unlit/Transparent",
			texture = "higgs1.png",
		},
		powerpellet={
			mesh = "bh.obj",
			shader = "Unlit/Transparent",
			texture = "higgs1.png",
		}
	}
}

SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
	color = {r=155,g=155,b=155,a=0},
	custom={
		_FrontTex = "DoubleLozengeXL.png",
		_BackTex = "DoubleLozengeXL.png",
		_RightTex = "<ALBUMART>",
		_LeftTex = "DoubleLozengeXL.png",
		_UpTex = "DoubleLozengeXL.png",
		_DownTex = "DoubleLozengeXL.png"
	}
}


SetBlockFlashes{
	sizescaler=0,
	sizescaler_missed = 0
}

SetTrackColors(GetAlbumArtPalette{mincount=1, maxcount=10})

SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	material = BuildMaterial{
	texture="PlainRing_1024.png",
	shader="VertexColorUnlitTintedAddSmooth",
	shadercolors = {_Color=255,255,255},
	colorMode = "none",
	shader = "VertexColorUnlitTintedAddDouble",
        },
	size=0,
	percentringed=.15,
	fullfuture = true,
	airtexture="PlainRing_1024.png",
	airshader="VertexColorUnlitTintedAddSmooth",
	airsize=0
}
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="zzzap",
	visible=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="clock.obj",
		--shadowcaster=true,
		--layer = iflofi(13,18),
		shader="VertexColorUnlitTintedAddSmooth",
		texture="PlainRing_1024.png",
		scale = {x=.45,y=.45,z=1}
	}
}
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="accelerator",
	visible=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="lhc_accelerator.obj",
		--shadowcaster=true,
		--layer = iflofi(13,18),
		shader="VertexColorUnlitTinted",
		texture="accelerator.jpg",
		--scale = {x=.45,y=.45,z=1}
	}
}
track = GetTrack()--get the track data from the game engine

Nodes_Zone2 = {}
RotationSpeeds_Zone = {}
RotationSpeeds_Zone6 = {}
for i=1,#track do
			if i%100 == 0 then
			Nodes_Zone2[#Nodes_Zone2+1] = i 
			RotationSpeeds_Zone[#RotationSpeeds_Zone+1] = {0,0,-5000}
				RotationSpeeds_Zone6[#RotationSpeeds_Zone6+1] = {0,0,5000}
				end
			end
wakeHeight = 0
SetWake{
	height = wakeHeight,
	fallrate = 0.95,
	shader = "VertexColorUnlitTinted",
	layer = 13,
	bottomcolor = {r=175,g=175,b=175},
	topcolor = "highway"
}
BatchRenderEveryFrame{
	prefabName="zzzap", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = nil,
	rotationspeeds = RotationSpeeds_Zone6,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 3,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
BatchRenderEveryFrame{
	prefabName="zzzap", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = nil,
	rotationspeeds = RotationSpeeds_Zone,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 4,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
BatchRenderEveryFrame{
	prefabName="accelerator", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes_Zone2,
	rotateWithTrack=true,
	maxShown=100,
	afternodereached_numbernodesrendered = 300000,
	maxDistanceShown=4000000,
	--rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = nil,
	--rotationspeeds = RotationSpeeds_Zone6,
	--offsets=Offsets_Zone2_alt,
	collisionLayer = 2,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
CreateRepeatedMeshRail{
    ahead_renderdist = 150,
    behind_renderdist = 50,
    spacing = 0, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "highway", --"highway" --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="meshrailproto1",
		shadowcaster = false,
		shadowreceiver = false,
		mesh="lhc_tube.obj",
		shader="MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=4.0}, {_Brightness=5.5}),
		textures = {_MainTex = "White.png", _MatCap = "matcapchrome.jpg"},
		height = 0,
	    shadercolors = {_Color="highway"},
		colorMode="highway",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		shadercolors={
			_Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1}
		}
	}
}

CreateRepeatedMeshRail{
    ahead_renderdist = 150,
    behind_renderdist = 50,
    spacing = 100, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highway" --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = false, --set true if using lighting
    
	gameobject={
		name="meshrailproto3",
		shadowcaster = false,
		shadowreceiver = false,
		mesh="lhc_cable_plug.obj",
		shader="VertexColorUnlitTinted",
		texture="plug.jpg",
		height = 0,
		colorMode="none",
		Color={r=255,g=255,b=255}
	}
}

CreateRepeatedMeshRail{
    ahead_renderdist = 150,
    behind_renderdist = 50,
    spacing = 5, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highway" --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = false, --set true if using lighting
    
	gameobject={
		name="meshrailproto4",
		shadowcaster = false,
		shadowreceiver = false,
		mesh="cables.obj",
		shader="VertexColorUnlitTinted",
		texture="cables.jpg",
		colorMode="none",
		Color={r=255,g=255,b=255}
		}
}

