jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

qualityLevel = GetQualityLevel()
hifi = qualityLevel > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

function iflofi(if_true, if_false)
  if qualityLevel<2 then return if_true else return if_false end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]

ispuzzle = skinvars.colorcount>1
fullsteep = jumping or skinvars.prefersteep or (not ispuzzle)

particleBaseSize = 2

fogColor = {255,233,255,0}

local randomAmbientBrightness = .9 + .1*math.random()
SetScene{
	fogenabled = true,
	--fogcolor = {255,216,251,255},
	fogcolor = fogColor,
	fogdensity = 1,
	fogstart = 500,
	fogend = 3500,
	fog_allowcolorshiftwhenjupming = false,

	ambientlight = {randomAmbientBrightness, randomAmbientBrightness, randomAmbientBrightness},

	glowpasses = 0,--ifhifi(4,0),
	glowspread = 0,--ifhifi(0.5,0),
	radialblur_strength = 0,--.5,
--	radialblur_strength = fif(jumping,2,0),
	water = jumping, --only use the water cubes in wakeboard mode
	--watertint = {r=255,g=255,b=255,a=30},
	watertint = {r=146,g=222,b=238,a=30},
	minwaterrandomdarkness = 100,
	watertype = 2,
	watertexture = "WaterCubesOutside.png",--texture used to color the dynamic "digital water" surface
	numvisiblewaterchunks = 8, -- double the normal rendering distance of the dynamic water cubes effect
	towropes = jumping,--use the tow ropes if jumping

	airdebris_count = 500,
	airdebris_density = 8,
	airdebris_particlesize = particleBaseSize, -- fif(jumping, 0.12, 0.09),
	airdebris_fieldsize = 300,
	airdebris_layer = 13,
	airdebris_texture = "wisp.png",
	airdebris_flashsizescaler = .6,

	use_intro_swoop_cam = false,
	hide_default_background_verticals = true,
	--usebackgroundcamera = false,
	useblackgrid=false
}

SetBlockFlashes{
	sizescaler=0,
	sizescaler_missed = 0
}

if hifi then
	AddPostEffect{
		depth= "background",
		builtin={
			name="GlobalFog",
			--color = {255,216,251,255},
			color = fogColor,
			height = fif(jumping,-700,-400),
			heightscale = 200
		}
	}
end

if hifi then
	AddPostEffect{
		depth= "foreground",
		builtin={
			name="AmplifyColor",
			lut = "LUTAC_contrast1.png"
			--color = fogColor,
			--height = 200
		}
	}
end

--if not jumping then
	SetBlocks{
		maxvisiblecount = 200,
		allow_mod_block_scaling = false,
		colorblocks={
			--reflect = not jumping,
			height = 0,
			--gameobject = {
				pos = {0,0,0},
				mesh = "1.obj",
				layer = 13,
				shader = "Diffuse", -- note: this shader behaved badly with GlobalFog until the shader was specified as Opaque
				texture = "AS2_ITM3D_Cube-Pickup_DIF.jpg",--,
				--childobjects={
				--	{
				--		pos = {0,0,0}, -- this is a world position. this object does not follow it's parent's position
				--		mesh = "AS2_ITM3D_Cube-Pickup.obj",
				--		layer = 13,
				--		shader = "GlassBumpDistort_AddReflection",
				--		shadersettings ={
				--			_ReflectMultiply = 0,
				--			_FresnelPower=0
				--		},
				--		textures = {
				--			_BumpMap="smallWavesMap.png"
				--		}
				--	}
				--},
			--},
		    float_on_water = jumping, -- if we're in wakeboard mode, float the blocks on the water
		    scale = {1.8,1.8,1.8}
		},
		greyblocks={
			--reflect = not jumping,
			--gameobject = {
				pos = {0,0,0},
				mesh = "2.obj",
				layer = 13,
				shader = "Diffuse", -- note: this shader behaved badly with GlobalFog until the shader was specified as Opaque
				texture = "AS2_ITM3D_Pyramid-Pickup_DIF.jpg",
				scale = {2.2,2.2,2.2}
				--childobjects={
				--	{
				--		pos = {0,0,0}, -- this is a world position. this object does not follow it's parent's position
				--		mesh = "AS2_ITM3D_Pyramid-Pickup.obj",
				--		layer = 13,
				--		shader = "GlassBumpDistort_AddReflection",
				--		shadersettings ={
				--			_ReflectMultiply = 0
				--		},
				--		textures = {
				--			_BumpMap="smallWavesMap.png"
				--		}
				--	}
				--}
			--}
		},
		powerups={--override the following objects in case the mod uses them
			powerpellet={
				--reflect = true,
				--gameobject = {
					pos = {0,0,0},
					mesh = "1.obj",
					layer = 13,
					scale = {2.2,2.2,2.2},
					shader = "Diffuse", -- note: this shader behaved badly with GlobalFog until the shader was specified as Opaque
					texture = "AS2_ITM3D_Cube-Pickup_DIF.jpg"
				--}
			}
		}
	}
--end

	SetPlayer{
		cameramode = "third",
		cameradynamics = "high",
		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0}},
			strafefactor = 1,
		camthird={
			--pos={0,2.6,-1.2},
			--pos={0,2,-0.5},
			pos={0,2.85,-1.5},
			rot={30,0,0},
			strafefactor = 1,
			pos2={0,5,-4},
			rot2={30,0,0},
			strafefactorFar = 1,
			transitionspeed = 2,
			--transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.5},
		vehicle={
			--mesh="AS2_ITM3D_Cube-Pickup_small.obj",
			mesh="AS2_ITM2D_Game-Vehicle.obj",
			texture="AS2_ITM2D_Game-Vehicle_DIF.jpg",
			scale = {x=1,y=1,z=1},	
			min_hover_height= 0,
			shadowcaster = true,
			shadowreceiver = true,
			max_hover_height = 0,
			use_water_rooster = false,
            smooth_tilting = false,
            --reflect = true,
            rollscaler = -1,
			pos={x=0,y=0,z=0},
			shader="Diffuse",
			layer = 13,
			renderqueue = 2000,
			thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
						perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
						--shader="VertexColorUnlitTinted",
						shader="Diffuse",
						layer = 13,
						renderqueue = 1, -- 3999,
						colorscaler = 2,
						extrusions=25,
						stretch=-0.1191,
						updateseconds = 0.025,
						instances={
							{pos={0,.26,-1.76},rot={0,0,0},scale={.3,.25,.7}}--,
							--{pos={.19,0.17,-1},rot={0,0,58.713},scale={.15,.15,.7}},
							--{pos={-.19,0.17,-1},rot={0,0,313.7366},scale={.15,.15,.7}}
						}}
		}
	}

SetSkybox{
	sky={
		month=2,
		hour=16,
		minute=50,
		longitude=185.6,--175,
		latitude = 45,
		cloudmaxheight=1.2,
		cloudminheight=-1.2,
		--cloudmaxheight=1.3,
		--cloudminheight=1.05,
		clouddensity=0.5,
		cirrusposition=0,
		useProceduralAmbientLight = false,--true,
		useProceduralSunLight = false,--true,
		flare = false,
		showsun = false
	},
	skysphere="SkyBox.png",
	color=fogColor
	--color={255,216,251,0}
}

--SetSkybox{
--	color = {colorsource="highway", staticalpha=0, minscaler=.3,maxscaler=.5},
--	custom={
--		_FrontTex = "Front.png",
--		_BackTex = "Back.png",
--		_LeftTex = "Left.png",
--		_RightTex = "Right.png",
--		_UpTex = "Top.png",
--		_DownTex = "Bottom.png"
--	}
--}

if jumping then
	SetTrackColors{ --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
	    {r=99, g=175, b=215},--,
	    {r=250, g=12, b=104}
	}
else
	SetTrackColors{ --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
	    {r=59, g=11, b=113},--purple
	    {r=187, g=50, b=2},
	    {r=247, g=194, b=6}--yellow
	}
end

SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}

--if not jumping then
	CreateLight{
		type= "directional",
		railoffset = 0,
		intensity = .5,
		shadows={type="hard",strength=.127},
		transform = {
			position={0,2,0}, rotation={90,0,0}
		},
		color={255,255,255}
	}
--end

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture="wisp.png",
	shader="VertexColorUnlitTintedAddSmooth",
	layer = 13, -- on layer13, these objects won't be part of the glow effect
	size=0, --22
	percentringed=.1,--ifhifi(2,.01),-- .2,
	airtexture="wisp.png",
	airshader="VertexColorUnlitTintedAddDouble",
	airsize=0
}

wakeHeight = 2
if jumping then wakeHeight=2 else wakeHeight = 0 end
extraWidth = trackWidth - 5
if jumping then extraWidth = 0 end
wakeStrafe = 7.5 + extraWidth
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = 0.95,
	--offsets = {{wakeStrafe,0,0}, {-wakeStrafe,0,0}, {0,0,0}},
	offsets = {{wakeStrafe,0,0}, {-wakeStrafe,0,0}},
	--strafe = wakeStrafe,
	shader = fif(jumping, "VertexColorUnlitTintedAddSmooth", "VertexColorUnlitTintedAddSmoothQuarter"),
	layer = fif(jumping, 11, 13), -- looks better not rendered in background when water surface is not type 2
	bottomcolor = fif(jumping, {r=114,g=148,b=255}, "highwayinverted"), -- {r=114,g=148,b=255},
	topcolor = {r=0,g=0,b=0}
}

CreateObject{
	name="Earth",
	tracknode="end",
	gameobject={
		transform={pos={0,0,22},scale={scaletype="intensity",min={1,1,1},max={1.1,1.1,1.1}}},
		mesh="earth.obj",
		shader="VertexColorUnlitTinted",
		shadercolors={
			_Color={255,255,255}
		}--,
		--texture="earth.jpg"
	}
}



--RAILS. rails are the bulk of the graphics in audiosurf. Each one is a 2D shape extruded down the length of the track.


--Mystical Start
----------------




track = GetTrack()--get the track data from the game engine



--detect when the track is in a loop or corkscrew
--note, some modes may already have set the "funkyrot" field
for i=1,#track do
	local roll = track[i].roll % 360
	local tilt = track[i].tilt % 360
	local absTilt = math.abs(tilt)
	local suspiciousRotation = false
	if roll > 5 or roll < -5 or (absTilt > 80 and absTilt < 260) then
		suspiciousRotation = true
	end

	if track[i].funkyrot or suspiciousRotation then
		track[i].funkyrot = true -- in case the current mode isn't setting funkyrot, we figured it out here
	else
		track[i].funkyrot = false
	end
end


do -- fix the funkyrot to start a bit earlier before loops (can be useful for some scaled mesh extrusions to not look weird)
	prevWasNormal = true
	local i = 1
	while i<=#track do
		if track[i].funkyrot then
			if prevWasNormal then
				if i > 80 then
					for j=i-80,i do
						track[j].funkyrot = true
					end
				end
			end

			prevWasNormal = false
		else -- and also to continue a ways further past loops
			if not prevWasNormal then
				if #track > i + 80 then
					local bound = i + 80
					local k = i
					while k<bound do
						track[k].funkyrot = true
						k = k + 1
					end
					i = k
				end
			end

			prevWasNormal = true
		end

		i = i + 1
	end
end

if jumping then
	rmrOffsets = {}
	for i=1,#track do
		rmrOffsets[#rmrOffsets+1] = {0,-2,0}
	end
end

mysticalNodes_Zone1 = {}
mysticalNodes_Zone2 = {}
mysticalNodes_Zone3 = {}
mysticalNodes_Zone4 = {}
mysticalNodes_Zone5 = {}
mysticalOffsets_Zone1 = {}
mysticalOffsets_Zone1_alt = {}
mysticalOffsets_Zone2 = {}
mysticalOffsets_Zone3 = {}
mysticalOffsets_Zone4 = {}
mysticalRotations_Zone4 = {}
mysticalOffsets_Zone5 = {}

mysticalRotationSpeeds_Zone1 = {}
mysticalRotationSpeeds_Zone3 = {}
mysticalRotationSpeeds_Zone5 = {}

minSafeStructuresOffset = 125

prevTunnelNode = 100
tunnelSpace = 200

function IsTiltTunnelFriendly(inputTilt)
	local tilt = inputTilt % 360
	local absTilt = math.abs(tilt)
	local prettyFlatNode = false
	if absTilt < 10 or absTilt > 350 then
		prettyFlatNode = true
	end

	return prettyFlatNode
end

for i=1,#track do
	if not track[i].funkyrot then -- don't place structures at loop/corkscrew nodes (not sure if necessary for these objects)
		--if i < #track*.2 then
			if i%100 == 0 then
				mysticalNodes_Zone1[#mysticalNodes_Zone1+1] = i
				local xOffset = minSafeStructuresOffset + 750*math.random()
				if math.random() > 0.5 then xOffset = xOffset * -1 end
				mysticalOffsets_Zone1[#mysticalOffsets_Zone1+1] = {xOffset,0,0}
				mysticalRotationSpeeds_Zone1[#mysticalRotationSpeeds_Zone1+1] = {0,33,0}

				xOffset = minSafeStructuresOffset*3 + 2*750*math.random()
				if math.random() > 0.5 then xOffset = xOffset * -1 end
				mysticalOffsets_Zone1_alt[#mysticalOffsets_Zone1_alt+1] = {xOffset,0,0}
			end
		--elseif i < #track*.4 then
			if i%2 == 0 then -- only check for a suitable spot every so often
				if i > (prevTunnelNode + tunnelSpace) then
					if IsTiltTunnelFriendly(track[i].tilt) then
						local checkSpan = 20
						local checkSpan2 = 50
						local checkSpan3 = 75
						local checkSpan4 = 100
						local allgood = false
						if ((#track > (i+checkSpan4)) and (i>(checkSpan+1))) then
							if IsTiltTunnelFriendly(track[i-checkSpan].tilt) and IsTiltTunnelFriendly(track[i+checkSpan].tilt) then
								if IsTiltTunnelFriendly(track[i-checkSpan2].tilt) and IsTiltTunnelFriendly(track[i+checkSpan2].tilt) then
									if IsTiltTunnelFriendly(track[i-checkSpan3].tilt) and IsTiltTunnelFriendly(track[i+checkSpan3].tilt) then
										if IsTiltTunnelFriendly(track[i-checkSpan4].tilt) and IsTiltTunnelFriendly(track[i+checkSpan4].tilt) then
											allgood = true
										end
									end
								end
							end
						end

						if allgood then
							mysticalNodes_Zone2[#mysticalNodes_Zone2+1] = i
							local xOffset = 0 -- minSafeStructuresOffset + 750*math.random()
							--if math.random() > 0.5 then xOffset = xOffset * -1 end
							mysticalOffsets_Zone2[#mysticalOffsets_Zone2+1] = {xOffset,0,0}
							--print("placed cave at tilt:"..absTilt)
							tunnelSpace = 200 + 200*math.random()
							prevTunnelNode = i
						end
					end
				end
			end
		--elseif i < #track*.6 then
			if i%94 == 0 then
				mysticalNodes_Zone3[#mysticalNodes_Zone3+1] = i
				local xOffset = minSafeStructuresOffset + 750*math.random()
				if math.random() > 0.5 then xOffset = xOffset * -1 end
				mysticalOffsets_Zone3[#mysticalOffsets_Zone3+1] = {xOffset,0,0}
				mysticalRotationSpeeds_Zone3[#mysticalRotationSpeeds_Zone3+1] = {0,33,0}
			end			
		--elseif i < #track*.8 then
			if (i+25)%85 == 0 then
				mysticalNodes_Zone4[#mysticalNodes_Zone4+1] = i
				local xOffset = minSafeStructuresOffset + 250*math.random()
				if math.random() > 0.5 then xOffset = xOffset * -1 end
				mysticalOffsets_Zone4[#mysticalOffsets_Zone4+1] = {xOffset,0,0}
				if xOffset < 0 then
					mysticalRotations_Zone4[#mysticalRotations_Zone4+1] = {0,90,0}
				else
					mysticalRotations_Zone4[#mysticalRotations_Zone4+1] = {0,-90,0}
				end
			end			
		--else
			if i%122 == 0 then
				mysticalNodes_Zone5[#mysticalNodes_Zone5+1] = i
				local xOffset = minSafeStructuresOffset + 450*math.random()
				if math.random() > 0.5 then xOffset = xOffset * -1 end
				mysticalOffsets_Zone5[#mysticalOffsets_Zone5+1] = {xOffset,0,0}
				mysticalRotationSpeeds_Zone5[#mysticalRotationSpeeds_Zone5+1] = {0,33,0}
			end			
		--end
	end
end

-- Object 1 - RED
------------------
--[[
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Mystical_Prefab_1a",
	visible = false,--we don't want to see this instance
	gameobject={
		layer = 18,
		pos={x=0,y=0,z=0},
		mesh="AS2_ITM3D_HPH_OBJ1.obj",
		shader="UnlitTexFoggable",
		diffuseinair = fif(jumping, true, false),
		shadercolors={
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="AS2_ITM3D_HPH_OBJ-1A_DIF.jpg",
		scale = {x=1,y=1,z=1}
	}
}

BatchRenderEveryFrame{
	prefabName="Mystical_Prefab_1a", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=mysticalNodes_Zone1,
	rotateWithTrack=false,
	maxShown=100,
	maxDistanceShown=3000,
	rerender_as_depthonly_inforeground = true,
	rotationspeeds = mysticalRotationSpeeds_Zone1,
	--scales = nil,
	offsets=mysticalOffsets_Zone1,
	collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
--]]


-- Object 1 - ORANGE
------------------
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Mystical_Prefab_1",
	visible = false,--we don't want to see this instance
	gameobject={
		layer = iflofi(13,18),
		pos={x=0,y=0,z=0},
		mesh="AS2_ITM3D_HPH_OBJ1.obj",
		shader="UnlitTexFoggable",
		--diffuseinair = fif(jumping, true, false),
		shadercolors={
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="AS2_ITM3D_HPH_OBJ-1A_DIF.jpg",
		scale = {x=1,y=1,z=1}
	}
}

BatchRenderEveryFrame{
	prefabName="Mystical_Prefab_1", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=mysticalNodes_Zone1,
	rotateWithTrack=false,
	maxShown=100,
	afternodereached_numbernodesrendered = 300,
	maxDistanceShown=3000,
	rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = nil,
	rotationspeeds = mysticalRotationSpeeds_Zone1,
	offsets=mysticalOffsets_Zone1_alt,
	collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}


-- Object 2 - 
------------------
if not jumping then
	CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
		name="Mystical_Prefab_2",
		visible = false,--we don't want to see this instance
		gameobject={
			layer = iflofi(13,18),
			pos={x=0,y=0,z=0},
			--mesh="AS2_ITM3D_HPH_OBJ2_scaledUp.obj",
			mesh="AS2_ITM3D_HPH_OBJ2.obj",
			shader="UnlitTexFoggable",
			--diffuseinair = fif(jumping, true, false),
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
			},
			texture="AS2_ITM3D_HPH_OBJ-2A_DIF.jpg",
			scale = {x=1.75,y=1.75,z=1.75}
		}
	}

	BatchRenderEveryFrame{
		prefabName="Mystical_Prefab_2", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
		locations=mysticalNodes_Zone2,
		rotateWithTrack=true,
		track_tilt_factor = 0,
		maxShown=100,
		afternodereached_numbernodesrendered = 300,
		maxDistanceShown=3000,
		rerender_as_depthonly_inforeground = iflofi(false, true),
		--scales = nil,
		offsets=mysticalOffsets_Zone2,
		collisionLayer = -1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
		testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
	}
end


CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Mystical_Prefab_3",
	visible = false,--we don't want to see this instance
	gameobject={
		layer = iflofi(13,18),
		pos={x=0,y=0,z=0},
		mesh="AS2_ITM3D_HPH_OBJ3.obj",
		shader="UnlitTexFoggable",
		--diffuseinair = fif(jumping, true, false),
		shadercolors={
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="AS2_ITM3D_HPH_OBJ-3A_DIF.jpg",
		scale = {x=1,y=1,z=1}
	}
}

BatchRenderEveryFrame{
	prefabName="Mystical_Prefab_3", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=mysticalNodes_Zone3,
	rotateWithTrack=false,
	maxShown=100,
	afternodereached_numbernodesrendered = 300,
	maxDistanceShown=3000,
	rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = nil,
	rotationspeeds = mysticalRotationSpeeds_Zone3,
	offsets=mysticalOffsets_Zone3,
	collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}



--WATERFALL object
----------------------------------------
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Mystical_Prefab_4",
	visible = false,--we don't want to see this instance
	gameobject={
		layer = iflofi(13,18),
		pos={x=0,y=0,z=0},
		mesh="AS2_ITM3D_HPH_OBJ4.obj",
		shader="UnlitTexFoggable",
		--diffuseinair = fif(jumping, true, false),
		shadercolors={
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="AS2_ITM3D_HPH_OBJ-4A_DIF.jpg",
		scale = {x=1,y=1,z=1}
	}
}

waterfallMaterial = BuildMaterial{
	shader="UnlitTexFoggable",
	texture = "waterfalls.jpg"
}

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Mystical_Prefab_4_Waterfall1",
	visible = false,--we don't want to see this instance
	gameobject={
		layer = iflofi(13,18),
		pos={x=0,y=0,z=0},
		mesh="waterfall_1step.obj",
		material = waterfallMaterial,
		scale = {x=1,y=1,z=1}
	}
}

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Mystical_Prefab_4_Waterfall2",
	visible = false,--we don't want to see this instance
	gameobject={
		layer = iflofi(13,18),
		pos={x=0,y=0,z=0},
		mesh="waterfall_2step.obj",
		material = waterfallMaterial,
		scale = {x=1,y=1,z=1}
	}
}

BatchRenderEveryFrame{
	prefabName="Mystical_Prefab_4", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=mysticalNodes_Zone4,
	rotateWithTrack=true,
	track_tilt_factor = 0,
	rotations = mysticalRotations_Zone4,
	maxShown=100,
	afternodereached_numbernodesrendered = 300,
	maxDistanceShown=3000,
	rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = nil,
	offsets=mysticalOffsets_Zone4,
	collisionLayer = -1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}

BatchRenderEveryFrame{
	prefabName="Mystical_Prefab_4_Waterfall1", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=mysticalNodes_Zone4,
	rotateWithTrack=true,
	track_tilt_factor = 0,
	rotations = mysticalRotations_Zone4,
	maxShown=100,
	afternodereached_numbernodesrendered = 300,
	maxDistanceShown=3000,
	--rerender_as_depthonly_inforeground = true,
	--scales = nil,
	offsets=mysticalOffsets_Zone4,
	collisionLayer = -1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}

BatchRenderEveryFrame{
	prefabName="Mystical_Prefab_4_Waterfall2", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=mysticalNodes_Zone4,
	rotateWithTrack=true,
	track_tilt_factor = 0,
	rotations = mysticalRotations_Zone4,
	maxShown=100,
	afternodereached_numbernodesrendered = 300,
	maxDistanceShown=3000,
	--rerender_as_depthonly_inforeground = true,
	--scales = nil,
	offsets=mysticalOffsets_Zone4,
	collisionLayer = -1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}









CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Mystical_Prefab_5",
	visible = false,--we don't want to see this instance
	gameobject={
		layer = iflofi(13,18),
		pos={x=0,y=0,z=0},
		mesh="AS2_ITM3D_HPH_OBJ5.obj",
		shader="UnlitTexFoggable",
		--diffuseinair = fif(jumping, true, false),
		shadercolors={
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="AS2_ITM3D_HPH_OBJ-5-7A_DIF.jpg",
		scale = {x=1,y=1,z=1}
	}
}

BatchRenderEveryFrame{
	prefabName="Mystical_Prefab_5", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=mysticalNodes_Zone5,
	rotateWithTrack=false,
	maxShown=100,
	afternodereached_numbernodesrendered = 300,
	maxDistanceShown=3000,
	rerender_as_depthonly_inforeground = iflofi(false, true),
	--scales = nil,
	rotationspeeds = mysticalRotationSpeeds_Zone5,
	offsets=mysticalOffsets_Zone5,
	collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}

waterfallTextureOffset = {0,0}
function Update(dt)
	if waterfallMaterial ~= nil then
		waterfallTextureOffset[1] = waterfallTextureOffset[1] - dt*2
		UpdateMaterial{
			material = waterfallMaterial,
			texturesettings = {offset = waterfallTextureOffset}
		}
	end
end












--[[
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Mystical_Prefab_1_Clear",
	visible = false,--we don't want to see this instance
	gameobject={
		layer = 13,
		pos={x=0,y=0,z=0},
		mesh="obj1.obj",
		shader="DepthWriteOnly",
		shadercolors={
			_Color = {0,0,0}
		},
		renderqueue=2000,
		scale = {x=1,y=1,z=1}
	}
}

BatchRenderEveryFrame{
	prefabName="Mystical_Prefab_1_Clear", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=mysticalNodes_Zone1,
	rotateWithTrack=false,
	maxShown=100,
	maxDistanceShown=3000,
	rotationspeeds = mysticalRotationSpeeds_Zone1,
	--scales = nil,
	offsets=mysticalOffsets_Zone1,
	collisionLayer = -1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}

-- Object 1 - ORANGE
------------------
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="Mystical_Prefab_1_Clear",
	visible = false,--we don't want to see this instance
	gameobject={
		layer = 13,
		pos={x=0,y=0,z=0},
		mesh="obj1.obj",
		shader="DepthWriteOnly",
		shadercolors={
			_Color = {0,0,0}
		},
		renderqueue=2000,
		scale = {x=1,y=1,z=1}
	}
}

BatchRenderEveryFrame{
	prefabName="Mystical_Prefab_1_Clear", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=mysticalNodes_Zone1,
	rotateWithTrack=false,
	maxShown=100,
	maxDistanceShown=3000,
	--scales = nil,
	offsets=mysticalOffsets_Zone1_alt,
	collisionLayer = -1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
--]]