jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end
hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end
skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
SetScene{
	glowpasses = ifhifi(0,0),
	glowspread = ifhifi(0,0),
	radialblur_strength = 1,
	watertype = 0,
	water = false,
	watertint = {r=250,g=250,b=250,a=30},
	watertexture = "transparent.png",
	towropes = jumping,
	airdebris_count = ifhifi(1,1),
	airdebris_density = ifhifi(1,1),
	usedefaultrails=false,
	useblackgrid=false,
	fullfuture = true,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep,1,.65)}
}
SetPuzzleGraphics{
	usesublayerclone = false,
	puzzlematerial={
		texture = "transparent.png",
		shader = "Particles/Additive"
	},
	puzzlematchmaterial={
		texture = "transparent.png",
		shader = "Particles/Additive"
	},
	puzzleflyupmaterial={
		texture = "transparent.png",
		shader = "Particles/Additive"
	}
}
SetTrackColors{
    {r=89, g=105, b=140},
	{r=69, g=85, b=140},
	{r=89, g=105, b=140},
    {r=123, g=97, b=153},
	{r=193, g=90, b=47},
	{r=193, g=90, b=47},
	{r=123, g=97, b=153},
	{r=89, g=105, b=140},
	{r=69, g=85, b=140},
	{r=89, g=105, b=140},
	{r=123, g=97, b=153},
	{r=193, g=90, b=47},
    {r=193, g=90, b=47}
}
SetBlockColors{
    {r=93, g=8, b=132},
	{r=1.0, g=0.20, b=0.25},
    {r=0.82, g=0.7098, b=0.1},
    {r=0.8, g=0.88, b=0.8},
	{r=0.8, g=0.88, b=0.8},
    {r=1,g=0,b=0}
}
	CreateLight{
		type= "directional",
		railoffset = -1,
		range = 10,
		intensity = 1,
		transform = {
			position={0,2,0}, rotation={.4,346.2,0}
		},
		color={155,155,155}
	}
SetBlocks{
allow_mod_block_scaling = false,
		colorblocks={
			mesh = "4.obj",
			shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
		    height = -1.0,
		    float_on_water = false,
		    scale = {1,1,1}
		},
		greyblocks={
			mesh = "7.obj",
			height = -1.3,
			shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		textures = {_MainTex="White.png", _MatCap="matcapchrome1.jpg"},
		scale = {0.9,0.9,0.9}},
		powerups={
			ghost={mesh = "5.obj",
			shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
			height = -1.0,
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture = "White.png"},
			whiteblock={mesh = "6.obj",

			shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
			height = -1.0,
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}}
			},
			powerpellet={mesh = "6.obj",

			shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
			height = -1.0,
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}}
			}
		}
	}
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,2.5,-1},
			rot={20,0,0}},
		camthird={
			pos={0,2,-2},
			rot={20,0,0},
			strafefactor = 0.75,
			pos2={0,5,-4},
			rot2={28,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
			
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = false,
			rollscaler = -1,
			panscaler = .1,
			pos={x=0,y=0,z=-1.0},
			mesh="2.obj",
			shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		textures = {_MainTex="White.png", _MatCap="matcapchrome1.jpg"},
			layer = 14,
			renderqueue = 2000,
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture="white.png",
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{-.1,-.1,0},{-.1,0,0},{-.1,.1,0},{0,.1,0},{.1,.1,0},{.1,0,0},{.1,-.1,0}},
						perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
						--shader="VertexColorUnlitTinted",
						shader="VertexColorUnlitTintedAddSmooth",
						layer = 14,
						renderqueue = 3999,
						colorscaler = 2,
						extrusions=22,
						stretch=-0.1,
						updateseconds = 0.025,
						instances={
							{pos={0.025,0.18,-1.597},rot={0,0,58.713},scale={.7,.7,.7}},
							{pos={0.565,-0.3,0.5},rot={0,0,58.713},scale={.7,.7,.7}},
							{pos={-0.54,-0.3,0.5},rot={0,0,58.713},scale={.7,.7,.7}}
						}}
		}
	}
r1 = math.random(1,12)
r2 = math.random(10,22)
r3 = math.random(1,59)
r5 = math.random(1,6)
r6 = math.random(1,6)
r7 = math.random(20,99)
r8 = math.random(1,3)
SetSkybox{
	sky={
		month=r1,
		hour=r2,
		minute=r3,
		longitude=185,--175,
		cloudmaxheight=r5,
		cloudminheight=-r6,
		clouddensity=r7/100,
		cirrusposition=0,
		useProceduralAmbientLight = true,
		useProceduralSunLight = true
	}
}
SetBlockFlashes{
	sizescaler=0,
	sizescaler_missed = 0
}
skyUpdateCounter = 0
function Update(dt)
	if r8>2 then
	--UpdateProceduralSky{latitude=(-140+GetSongCompletionPercentage()*250),longitud=185.6}
	skyUpdateCounter = skyUpdateCounter + dt
	if(skyUpdateCounter > .2) then--don't update sky colors every frame
		skyUpdateCounter = 0
		local lat = -70 + GetSongCompletionPercentage()*180
		--local lat = -109 + GetSongCompletionPercentage()*219
		lat = math.min(lat,100)
		UpdateProceduralSky{latitude=lat}
	end
	end
end

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture="transparent.png",
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAlpha2",
	size=66,
	percentringed=.01,
	fullfuture = true,
	airtexture="transparent.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=16
}

wakeHeight = 2
if jumping then wakeHeight=2 else wakeHeight = 0 end
SetWake{
	height = wakeHeight,
	fallrate = 0.95,
	shader = "VertexColorUnlitTinted",
	layer = 13,
	bottomcolor = {r=175,g=175,b=175},
	topcolor = "highway"
}